<?php

/*
	Plugin Name: Youtube Profile Field
	Plugin URI: http://jayj.dk
	Description: Adds an additional field to the user profile page and allow you to show your videos on your website.
	Author: Jayj.dk
	Author URI: http://jayj.dk
	Version: 2.0.1
*/


if(is_admin() ) {
	include('youtube-admin.php'); // Include youtube-admin.php
}

load_plugin_textdomain('youtubeprofile', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/languages', dirname(plugin_basename(__FILE__)).'/languages'); // Load translation

/* Create the function */
function show_video($count = '', $userid = 1) {
	
	/* Get options */
	$ypf_options = get_option('youtubeprofile');
	
	$y_youtubeuser = get_the_author_meta('youtube', $userid); // Your Youtube username entered in your profile
	
	if($count) { 
		$y_youtubecount = $count;
	} else {
		$y_youtubecount = $ypf_options['count']; 
	}
	
	
	$y_heading_start = $ypf_options['headingStart'];
	$y_heading_end = $ypf_options['headingEnd'];
	$y_width = $ypf_options['width'];
	$y_height = $ypf_options['height'];

	
	// Get the videos
	include_once(ABSPATH . WPINC . '/feed.php'); // Include SimplePie from WordPress Core
	
	$rss = fetch_feed("http://gdata.youtube.com/feeds/base/users/$y_youtubeuser/uploads");
	$maxitems = $rss->get_item_quantity($y_youtubecount); 
	
	$rss_items = $rss->get_items(0, $maxitems);
	
	if ($maxitems == 0) { 
		echo __('<p>No videos where found.</p>', 'youtubeprofile'); 
	} else {  // Loop through each feed item (video)
	
	foreach ($rss_items as $item) : 
	
	?>
		
       <?php 
	   		// Find the video ID
	   		$getid = $item->get_permalink();
	 		$id1 = explode('?', $getid);
			$id = explode('=', $id1[1]);
		?>
        
        <div class="youtube-video">
			<?php echo $y_heading_start; ?>
            	<a href="<?php echo $item->get_permalink(); ?>"><?php echo $item->get_title(); ?></a>
			<?php echo $y_heading_end; ?>
        
           <object type="application/x-shockwave-flash" width="<?php echo $y_width; ?>" height="<?php echo $y_height; ?>" data="http://www.youtube.com/v/<?php echo $id[1]; ?>&amp;fs=1">
                <param name="movie" value="http://www.youtube.com/v/<?php echo $id[1]; ?>&amp;fs=1" />
                <param name="allowFullScreen" value="true" />
                <param name="wmode" value="transparent" />
            </object>
         </div>

	<?php endforeach;
	
	}


} // End show video



// Create the Youtube profile field


// For 2.9 

if ( function_exists('require_if_theme_supports') ) { 
	
	function youtube_field($contactmethods) {
		$contactmethods['youtube'] = 'Youtube username';
		return $contactmethods;
	}
	
	add_filter('user_contactmethods','youtube_field',10,1);
	
} else { // 2.8
	
	function youtube_field() {
	
		global $user_ID;
		
		if ( preg_match('&profile.php&', $_SERVER['REQUEST_URI'])) {
			$id = $user_ID;
		} elseif($_GET['user_id']) {
			$id = $_GET['user_id'];
		}
		
		$youtube = get_usermeta($id, 'youtube'); 
	
	?>
	
		<!-- Youtube profile field HTML -->
		<table class="form-table">
		<h3>Youtube</h3>
		<tr>
			<th><label for="youtube"><?php _e('Youtube username', 'youtubeprofile'); ?></label></th>
			<td><input type="text" name="youtube" id="youtube" value="<?php echo $youtube; ?>" class="regular-text" />
				<!-- <span class="description">You can write a description here if you want</span> -->
			</td>
		</tr>
		</table> 
	
	<?php 
	} // End youtube_field
	
	function save_youtube_field() {
	
		global $user_ID;
		
		if (preg_match('&profile.php&', $_SERVER['REQUEST_URI'])) {
			$id = $user_ID;
		} elseif($_GET['user_id']) {
			$id = $_GET['user_id'];
		}
		
		$youtube = $_POST['youtube'];
		
		update_usermeta($id, 'youtube', $youtube);
	}
	
	
	// Add it to the profile page
	add_filter('show_user_profile','youtube_field'); 
	add_action('edit_user_profile', 'youtube_field');
	add_action('profile_update', 'save_youtube_field');
	
} 


// Create the shortcode

function youtube_user_shortcode($atts) {
	extract(shortcode_atts(array(
		'display' => '1',
		'id' => '',
	), $atts));
	
	// If ID not is empty, show the video
	if ( $id != '' ) { 
		return '<object type="application/x-shockwave-flash" width="480" height="295" data="http://www.youtube.com/v/' . $id . '">
			<param name="movie" value="http://www.youtube.com/v/' . $id .'" />
			<param name="allowFullScreen" value="true" />
			<param name="wmode" value="transparent" />
        </object>';
	} elseif ( function_exists('show_video') ) { // If ID is empty, show the latest video
		return show_video($display);
	} else {
		return __('The video could not be found');
	}
}

add_shortcode('youtube-user', 'youtube_user_shortcode');
add_filter('widget_text', 'do_shortcode'); // Allows you to use the shortcode in text widgets 

?>